#!/bin/bash

LOG_PATH_FUNC() {
	echo "[Please enter the Log folder path] :"
	read LOGPATH
	case $LOGPATH in 
		"") LOG_PATH_FUNC ;;
		*)  ;;
	esac
}

CREATE_FOLDER_FUNC() {
    SAVE_location=Result
	mkdir ./$SAVE_location
}

LOG4J_SCAN_FUNC() {
	echo "[+][log4j search...]"
	egrep -I -i -r '\$(\{|%7B)jndi:(ldap[s]?|rmi|dns|nis|iiop|corba|nds|http):/[^\n]+' $LOGPATH >> ./$SAVE_location/temp.txt 2> /dev/null
    grep -I -i -r -f ./config/string.txt $LOGPATH >> ./$SAVE_location/temp.txt 2> /dev/null
}

RESULT_COUNT_FUNC() {
	RESULT_COUNT=$(cat ./$SAVE_location/temp.txt | wc -l)
	_PATH=$(pwd)
	echo "[+][log4j search result] :"
	echo "[+] "$RESULT_COUNT" Detection (Result Save Path : "$_PATH/$SAVE_location/Result.txt")"
}

RESULT_FUNC() {
	echo -e [log4j search result : $RESULT_COUNT Detected] >> ./$SAVE_location/Result.txt
	cat ./$SAVE_location/temp.txt >> ./$SAVE_location/Result.txt
	rm -rf ./$SAVE_location/temp.txt
}

#Main
LOG_PATH_FUNC
CREATE_FOLDER_FUNC
LOG4J_SCAN_FUNC
RESULT_COUNT_FUNC
RESULT_FUNC
